<?
include $_SERVER["DOCUMENT_ROOT"]."/phplibs/inc.php"; 
include $_SERVER["DOCUMENT_ROOT"]."/phplibs/Smarty/Smarty.class.php"; 
include_once "DB.php"; 

class Empmaint{
    var $_smarty;
    var $_params = array(
             'gender'   => array(1=>'男性', 2=>'女性'),
             'worktype' => "",             
             'dept'     => ""
             );
    var $_dsn = array(
            'phptype'  => 'SQL4G',
            'database' => 'DB1',
            'user' => 'sa',
            'password' => 'sa'
      );
      
    function Empmaint(){
        $this->_smarty = new Smarty();
        $this->_smarty->template_dir = $_SERVER["DOCUMENT_ROOT"].'templates';
    }

    function viewForm(){
        $this->_smarty->assign('title',"社員検索/登録");
        $this->createCheckBox();
        $this->_smarty->assign('params',$this->_params);
        $this->_smarty->display('empmaint.tpl');
    }

    function searchForm(){
        $this->createCheckBox();
        $sql = $this->createSearchSQL();
        $db = DB::connect($this->_dsn);        
        $ret = $db->query($sql);
        $arr = array();
        while ($row =& $ret->fetchRow(DB_FETCHMODE_ORDERED)) {
            $emp = null; 
            $emp["EMP_ID"]          = $row[0];
            $emp["DEPT_NAME"]       = $row[1];
            $emp["WORK_TYPE_NAME"]  = $row[2];
            $emp["NAME"]            = $row[3];
            $emp["SEX"]             = $row[4];
            array_push($arr,$emp);     
        }
        $this->_smarty->assign('data',$arr);        
        $db->disconnect();        
        $this->_smarty->assign('params',$this->_params);
        $this->_smarty->display('empmaint_searchret.tpl');
    }
    
   function addForm(){                
        $this->createCheckBox();
        $this->_smarty->assign('params',$this->_params);
        $this->_smarty->assign('mode','new');
        $this->_smarty->display('empmaint_edit.tpl');
    }
    
    function editForm(){        
        $sql = $this->createEditSQL($_GET['id']);
        $db = DB::connect($this->_dsn);        
        $ret = $db->query($sql);        
        
        $row =& $ret->fetchRow(DB_FETCHMODE_ORDERED); 
        $db->disconnect(); 
        
        // セッションまたはクッキーに対象となる EMP_ID を保存
        $_SESSION['id'] = $_GET['id'];
        setcookie("id", $_GET['id'], time()+60*10);
        // 

        $this->_smarty->assign('deptcd',$row[1]);
        $this->_smarty->assign('worktypecd',$row[2]);
        $this->_smarty->assign('name',$row[3]);
        $this->_smarty->assign('gender',$row[5]);
                
        $this->createCheckBox();
        $this->_smarty->assign('params',$this->_params);
        $this->_smarty->display('empmaint_edit.tpl');
    }

    function updateForm(){
        // セッションまたはクッキーから EMP_ID を取得する       
        $sql = $this->createUpdateSQL($_SESSION['id']);
        //$sql = $this->createUpdateSQL($_COOKIE["id"]);
        //
        
        $db = DB::connect($this->_dsn);
        $ret = $db->query($sql);                                            
        $db->disconnect();    
        $this->_smarty->assign('title','社員更新が完了しました');
        $this->_smarty->display('empmaint_done.tpl');
    }

    function returnForm(){
        $this->_smarty->assign('title','社員検索に戻ります');
        $this->_smarty->display('empmaint_done.tpl');
    }
    
    function deleteForm(){
        //$id = $_COOKIE['id'];
        $id = $_SESSION['id'];
        $sql = $this->createDeleteSQL($id);
        $db = DB::connect($this->_dsn);
        $ret = $db->query($sql);                                            
        $db->disconnect();    
        $this->_smarty->assign('title','社員削除が完了しました');
        $this->_smarty->display('empmaint_done.tpl');
    }
       
    function insertForm(){
        
        if ($_POST['name'] === "" || !isset($_POST['gender']) || $_POST['dept'] === "" || $_POST['worktype'] === ""){
            $this->_smarty->assign('msg','未入力項目があります');
            $this->viewForm();
            exit;
        }

        $db = DB::connect($this->_dsn);      
        $ret = $db->query("SELECT MAX(EMP_ID) FROM T_EMP;");
        $row =& $ret->fetchRow(DB_FETCHMODE_ORDERED);
        $id = $row[0] + 1;
        
        $ret = $db->query($this->createInsertSQL($id));
        $db->disconnect(); 
        $this->_smarty->assign('title','社員登録が完了しました'.$id);
        $this->_smarty->display('empmaint_done.tpl');
    } 
    
    
    function createCheckBox(){
        $db = DB::connect($this->_dsn);        
        $arr = array();
        $ret = $db->query("SELECT * FROM M_DEPT;");
        while ($row =& $ret->fetchRow(DB_FETCHMODE_ORDERED)) {
            $arr[$row[0]] = $row[1];
        }
        $this->_params["dept"] = $arr;

        $ret = $db->query("SELECT * FROM M_WORK_TYPE;");
        while ($row =& $ret->fetchRow(DB_FETCHMODE_ORDERED)) {
            $arr[$row[0]] = $row[1];
        }
        $this->_params["worktype"] = $arr;
        $db->disconnect();
    }
    
    function createUpdateSQL($id){
        $updateSQL = "UPDATE T_EMP SET ";
        $setSQL = "";
        if ($_POST['name'] !== "" ){
            $setSQL = " NAME = '" . $_POST['name'] . "'";
        }
        if (isset($_POST['gender'])){
            if ($setSQL !== "") $setSQL .=", "; 
            $setSQL .= " SEX = " . $_POST['gender'];
        }
        if ($_POST['dept'] !== ""){
            if ($setSQL !== "") $setSQL .=", "; 
            $setSQL .= " DEPT_CODE = " . $_POST['dept'];
        }
        if ($_POST['worktype'] !== ""){
            if ($setSQL !== "") $setSQL .=", "; 
            $setSQL .= " WORK_TYPE_CODE = " . $_POST['worktype'];
        }
        $updateSQL = $updateSQL . $setSQL . " WHERE EMP_ID = " . $id ;
        return $updateSQL;
    }
    
    function createDeleteSQL($id){
        return "DELETE FROM T_EMP WHERE EMP_ID = ". $id ;
    }
    
    function createInsertSQL($id){
        //INSERT INTO T_EMP(EMP_ID, DEPT_CODE, WORK_TYPE_CODE, NAME, ENTER_DATE, SEX, CREATE_DATETIME, UPDATE_DATETIME) VALUES ( 1 ,  1 ,  1 ,  '水島清義' ,  '1997-09-14' ,  1 ,  '2007-12-19 14:53:59.0' ,  '2007-12-19 14:53:59.0' );
        return "INSERT INTO T_EMP(EMP_ID, DEPT_CODE, WORK_TYPE_CODE, NAME, ENTER_DATE, SEX, CREATE_DATETIME, UPDATE_DATETIME) VALUES (".
                " $id , " . $_POST['dept'] . "," . $_POST['worktype'] . ",'". $_POST['name']. "'," . " '1997-09-14' ," . $_POST['gender'] . "," ."  '2007-12-19 14:53:59.0' ,  '2007-12-19 14:53:59.0' );";
    }
    
    function createEditSQL($id){
        return "SELECT * FROM T_EMP WHERE EMP_ID = ". $id ;
    }
    
    function createSearchSQL(){
    	$retSQL = "SELECT EMP_ID, DEPT_NAME, WORK_TYPE_NAME, NAME, CASEWHEN(SEX=1,'男性','女性') FROM T_EMP E, M_WORK_TYPE W, M_DEPT D WHERE E.DEPT_CODE = D.DEPT_CODE AND E.WORK_TYPE_CODE = W.WORK_TYPE_CODE ";
        $whereSQL = "";
        if ($_POST['name'] !== "" ){
            $whereSQL = " AND NAME like '%" . $_POST['name'] . "%'";
        }
        if (isset($_POST['gender'])){
            $whereSQL .= " AND SEX = " . $_POST['gender'];
        }
        if ($_POST['dept'] !== ""){
             $whereSQL .= " AND E.DEPT_CODE = " . $_POST['dept'];
        }
        if ($_POST['worktype'] !== ""){
            $whereSQL .= " AND E.WORK_TYPE_CODE = " . $_POST['worktype'];
        }
        return $retSQL . $whereSQL . " ORDER BY EMP_ID;";
    }
}

function doMain(){
    session_start();
    $form = new Empmaint();
    if ($_POST) {
        if ($_POST['search'] != '') {
            $form->searchForm();
        } else if($_POST['update'] != ''){
        	$form->updateForm();
        } else if($_POST['delete'] != ''){
            $form->deleteForm();
        } else if($_POST['insert'] != ''){
            $form->insertForm();            
        } else if($_POST['add'] != ''){
            $form->addForm();
        } else if($_POST['return'] != ''){
            $form->returnForm();
        } else{
        	$form->viewForm();
        }
    } else if ($_GET) {
    	if ($_GET['action'] == 'edit') {
            $form->editForm();
        } else {
        	$form->viewForm();
        }
    } else {
    	$form->viewForm();
    }
    //session_destroy();
}

doMain();
?> 